#!/usr/bin/env python
# -*- coding: utf-8 -*-
# xDevs.com Magic PPM
import sys
import csv
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.dates as mdates
import datetime
from scipy.ndimage.filters import gaussian_filter1d
#matplotlib.use('Agg')
    
mode = 10

if (mode == 10):
    # DSV data parser to calculate alpha/beta values
    fn_input = "log_2019-06-24_190620.tmp.csv"
    fn_output = "tcr_math_output_t8use.txt"

    temp = []
    val = [[]]
    ral = [[]]
    polyz = []
    for ival in range (0,17):
        val.append([])
    for ival in range (0,17):
        ral.append([])
    #val2 = []
    #val3 = []
    #val4 = []
    #val5 = []
    #val6 = []
    cnt = 0
    alpha = []
    beta = []
    amb = []
    gain = []
    tvalue = []
    c1 = []
    c2 = []
    press = []
    delta = []
    zerotctemp = []
    valzerotc = []
    cnx = []
    date = []
    chop_samples = 10
    
    num_lines = sum(1 for line in open(fn_input))
    for dval in range (0,num_lines-chop_samples):
        date.append(" ")
    #vref = [7.151292766e+00,9.991393197e+00,7.158675987e+00,9.983004444e+00,7.136260692e+00,9.962210853e+00,7.151827323e+00,9.981525961e+00,7.108384358e+00,9.923200475e+00,7.156064144e+00,9.999977018e+00,7.160140665e+00,1.000038978e+01,7.162542902e+00,9.996671352e+00]
    vref = [9.9999568,9.9999568,1.000001524e+01,1.000001524e+01,1.000001524e+01,7.085451500e+00,1.000001524e+01,0.000000000e+00,0.000000000e+00,0.000000000e+00,0.000000000e+00,0.000000000e+00,0.000000000e+00,0.000000000e+00,0.000000000e+00,0.000000000e+00,1.200000000e+01]
    
    col_active = 1

    with open(fn_input) as csvfile:
        spamreader = csv.reader(csvfile, delimiter=',', quotechar='|')
        is_first = True
        dcount = 0
        for row in spamreader:
            cnt = cnt + 1
            dcount = dcount + 1
            if is_first:
                is_first = False
                continue
            #print ("%d" % cnt)
            if cnt <= chop_samples:
                continue
            else:
                cnx.append(cnt - (chop_samples+1))
                if ( 20 <= (float(row[3])) - 0 <= 40.0):
                    temp.extend([ float(row[3]) - 0 ])
                else:
                    temp.extend([ 25 ])
                #amb.extend([ float(row[4]) ])
                #press.extend([ float(row[5]) ])
                date[dcount - (chop_samples+1)] = datetime.datetime.strptime (row[0],"%Y-%m-%d %H:%M:%S")
                #date.extend(row[0])#.strftime('%d/%m/%y-%h:%m:%s')
                val[0].extend([ ( (float(row[2]) / vref[0]) - 1) * 1e6 ]) #val1
                
                ral[0].extend([  float(row[2]) ]) #val1
    csvfile.close()
    
    tdelta = np.amax(temp) - np.amin(temp)
    reftemp = 23.00
    nominal = []
    median = []
   
    #print "Temperature min = %.3f , max = %.3f, delta = %.3f C" % (np.amin(temp), np.amax(temp), tdelta)
    #print "REF temp = %.3f C" % reftemp
        
    print "\033[2J"
    with open(fn_output, 'a') as logfile:
        logfile.write ("\r\rFile = %s\r" % fn_input)
    logfile.close()
    
    for zval in range (0,col_active):
        #nominal = [9.999957591e+00, 9.999963348e+00, 0, 0, 1.000001420e+01, 9.999958800e+00, 9.515830000e-01, 0, 0]
        nominal.append(np.mean(ral[zval][:30]))
        polyz.append(np.polyfit(temp, ral[zval], 2))
        c2.append(polyz[zval][0])
        c1.append(polyz[zval][1])
        gain.append(polyz[zval][2])
        tvalue.append(c2[zval] * reftemp*reftemp + c1[zval]*reftemp + gain[zval])
        alpha.append((c1[zval] + 2*reftemp*c2[zval]) / tvalue[zval]*1e6 )
        beta.append(c2[zval] / tvalue[zval]*1e6 )
        delta.append((tvalue[zval] - nominal[zval]) / nominal[zval] * 1e6)
        zerotctemp.append(-alpha[zval] / 2 / beta[zval] + reftemp)
        valzerotc.append(nominal[zval] + (zerotctemp[zval]) * c1[zval] + (zerotctemp[zval])*2*c2[zval])
        median.append(np.median(ral[zval]))
        
        if (gain[zval] != 0):
            print "\033[37;1m\r\nNominal       :", nominal[zval]
            print ("Median        : %.8f" % median[zval])
            print ("Column number : %d " % zval), polyz[zval], "Total samples = %d" % len(ral[zval])
            print ("c1            : %e" % c1[zval])
            print ("c2            : %e" % c2[zval])
            print ("g             : %e" % gain[zval])
            print ("Value T23     : %.6f" % (tvalue[zval]))
            print ("\033[36;1mAlpha T23     : %.4f ppm/K       " % (alpha[zval])),
            print ("Beta      : %.4f ppm/K/2                " % (beta[zval])),
            print ("Delta T23 : %.3f ppm         \033[39;1m" % (delta[zval]))
            print ("\033[35;1mZero TC       : %.3f C \033[39;0m" % (zerotctemp[zval])),
            print ("\033[32;1m          Delta ZeroTC : %.6f\033[39;0m" % (valzerotc[zval]))
            
            with open(fn_output, 'a') as logfile:
                logfile.write ("\rColumn number : %d\r" % zval), polyz[zval], "Total samples = %d" % len(ral[zval])
                logfile.write ("Nominal       : %.8f\r" % nominal[zval])
                logfile.write ("c1            : %e\r" % c1[zval])
                logfile.write ("c2            : %e\r" % c2[zval])
                logfile.write ("g             : %e\r" % gain[zval])
                logfile.write ("Value T23     : %.8f\r" % (tvalue[zval]))
                logfile.write ("Alpha T23     : %.4f ppm/K     \r" % (alpha[zval])),
                logfile.write ("Beta          : %.4f ppm/K/2   \r" % (beta[zval])),
                logfile.write ("Delta T23     : %.3f ppm       \r" % (delta[zval]))
                logfile.write ("Zero TC       : %.3f C \r" % (zerotctemp[zval])),
                logfile.write ("Delta ZeroTC  : %.8f   \r" % (valzerotc[zval]))
            logfile.close()
    w = 20
    h = 16
    fig,ax = plt.subplots()
    fig.set_size_inches(w,h)
    plt.tight_layout(rect=[0.03, 0.03, 0.96, 0.98], w_pad=0.4, h_pad=0.4)                                # Reduce margins around the graph
        
    plt.xlabel('Temperature', fontsize=18)
    plt.ylabel('Deviation from REF, ppm', fontsize=18) #$\mu$V
    
    #new_x = dates.num2date(date)
    
    avgpower = 128
    
    val1aver = gaussian_filter1d(val[0], sigma=avgpower)
    
    temp2aver = gaussian_filter1d(temp, sigma=8)
    
    colors = ['#00aa00', '#009955', '#005599', '#009999', '#aa0000', '#770022', '#f58231', '#911eb4', '#f032e6', '#00a68c', '#664433', '#1f38e3', '#ff0000', '#ec18a0', '#dbb201', '#1c2b33', '#003355', '#fc007f']
    
    avglinestype = 'solid'
    avglinestypen = 'none'
    
    plt.title('bitseeker Data, 34401A vs FX, USA Cal Club 2', fontsize=22)
    ax.plot(date, val1aver, '-', label='CH1',  linewidth=3.0, color=colors[0], linestyle=avglinestype, marker='.', ms=1)
    #ax.plot(date, val2aver, '-', label='CH2',  linewidth=2.0, color=colors[1], linestyle='dashed', marker='.', ms=1)
    #ax.plot(date, val3aver, '-', label='CH3',  linewidth=3.0, color=colors[2], linestyle=avglinestype, marker='.', ms=1)
    
    ax.plot(date, val[0], '-'  , label='CH1',  linewidth=1.0, alpha=0.1, color=colors[0] )#, linestyle='none', marker='.', ms=6)
    #ax.plot(date, val[1], '-'  , label='CH2',  linewidth=1.0, alpha=0.3, color=colors[1] )#, linestyle='none', marker='.', ms=6)
    #ax.plot(date, val[2], '-'  , label='CH3',  linewidth=1.0, alpha=0.1, color=colors[2] )#, linestyle='none', marker='.', ms=6)

    
    #ax.plot(date, temp2aver, '-', label='TEMP', linewidth=3.0, color='#000000', linestyle='dotted', marker='.', ms=1)
    
    #start, end = ax.get_ylim()
    #startx, endx = ax.get_xlim()
    axis_y_step = 0.01
    #axis_x_step = 1
    ex = np.arange(1,2000)
    #ax.yaxis.set_ticks(np.arange(start, end)) # axis_y_step))
    ax.yaxis.set_ticks(np.arange(5, 12, 0.2)) # axis_y_step))
    #ax.xaxis.set_ticks(np.arange(17.5, 41.5, 0.5)) # axis_y_step))
    #ax.xaxis.set_ticks(np.arange(1, 20000, 120)) # axis_y_step))
    #ax.xaxis.set_ticks(np.arange(startx, endx)) #, axis_x_step))
    
    ax2 = ax.twinx()  # instantiate a second axes that shares the same x-axis
    ax2.set_ylabel(u'Temperature, °C', fontsize=18)  # we already handled the x-label with ax1
    ax.margins(x=0)
    ax2.margins(x=0)
    ax2.plot(date, temp2aver, '-.', label='TEMP?', linewidth=1.0, color='#ff0000', linestyle='dotted', marker='.', ms=2)
    #ax2.plot(date, amb, '-.', label='TEMP?', linewidth=1.0, color='#0330aa', linestyle='dotted', marker='.', ms=2)
    #ax2.plot(date, press, '-.', label='TEMP?', linewidth=1.0, color='#0000ee', linestyle='dotted', marker='.', ms=2)
    ax2.tick_params(axis='y', labelcolor='#000000')
    legendlabel = ["34401A REF"]#, "3458B", "3458C", "3458D", "K2002-6", "K2002-4", "8508A"]# "9.9815132 CH8", "7.1083426 CH9", "9.9231395 CH10", "7.1560244 CH11", "FX 792X", "7.1601550 CH13", "1.0000411 CH14", "7.1625227 CH15", "9.9966437 CH16", "Zero Ref"]
    legendlabel2 = ["Ambient T", "RH", "Pressure"]#, "Ambient"]
    ax.legend(legendlabel, loc=4, fancybox=True, framealpha=1, borderpad=1, markerscale=10)
    ax2.legend(legendlabel2, loc=2, fancybox=True, framealpha=1, borderpad=1, markerscale=10)
    ax.grid(True, color='#cccccc')
    ax2.yaxis.set_ticks(np.arange(23, 30, 0.2)) # axis_y_step))
    ax.xaxis.set_major_formatter(mdates.DateFormatter("%b %d, %H:%M:%S"))
    ax.xaxis.set_minor_formatter(mdates.DateFormatter("%b %d, %H:%M:%S"))

    vmed = []
    vmin = []
    vmax = []
    sdev = []
    tmin = np.amin(temp)
    tmax = np.amax(temp)
    temppp = tmax - 18
    tempco = []
    colormap = [0,1,2,3,4,5,6,7,8,9,5,6,7,7,8,8]
    
    for label in (ax.get_xticklabels() + ax.get_yticklabels()):
        #label.set_fontname('Arial')
        label.set_fontsize(13)
    
    for stats in range (0, col_active):
        vmed.extend([0])
        vmin.extend([0])
        vmax.extend([0])
        sdev.extend([0])
        tempco.extend([0])
        
    for stats in range (0, col_active):
        vmed[stats] = np.median(val[stats])
        vmin[stats] = np.amin(val[stats])# - vstep
        vmax[stats] = np.amax(val[stats])# + vstep
        sdev[stats] = np.std(val[stats]) # SDEV
        tempco[stats] = ((vmax[stats] - vmin[stats]) / temppp) 
        if ((stats % 2) == 0):
            bgclr = "#ffffff"
        else:
            bgclr = "#eeeeff"
        
        spacing_xleg = 0.1
        
        
        plt.text(0.01 + (stats * spacing_xleg), 0.075, 'Max[%d] : %.3f ppm' % (stats, vmax[stats]),
            horizontalalignment='left',
            verticalalignment='top', backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.09, 'Min[%d] : %.3f ppm' % (stats, vmin[stats]),
            horizontalalignment='left',
            verticalalignment='top', backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.105,'Median[%d] : %.3f ppm' % (stats, vmed[stats]),
            horizontalalignment='left',
            verticalalignment='top',backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.12,'Sdev[%d] : %.3f ppm' % (stats, sdev[stats]),
            horizontalalignment='left',
            verticalalignment='top',backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.16, '%s' % (legendlabel[stats]),
            horizontalalignment='left',
            verticalalignment='top',backgroundcolor=bgclr,
            transform = ax.transAxes, size=12, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.135, 'REF[%d] : %.7f V' % (stats, vref[stats]),
            horizontalalignment='left',
            verticalalignment='top', backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.015, 'TCbox : %.3f ppm/K' % ( tempco[stats] ),
            horizontalalignment='left',
            verticalalignment='top',backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.03, 'Alpha : %.3f ppm/K' % ( alpha[stats] ),
            horizontalalignment='left',
            verticalalignment='top',backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.045, 'Beta : %.3f ppm/K2' % ( beta[stats] ),
            horizontalalignment='left',
            verticalalignment='top',backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        plt.text(0.01 + (stats * spacing_xleg), 0.06, 'Zero TC : %.3f C' % ( zerotctemp[stats] ),
            horizontalalignment='left',
            verticalalignment='top',backgroundcolor=bgclr,
            transform = ax.transAxes, size=9, color=colors[colormap[stats]])
        
    
    smax = len(val[0])
    plt.text(0.07, -0.04,'xDevs.com | USA Cal Club 2',
        horizontalalignment='center',
        verticalalignment='center',
        transform = ax.transAxes, size=12)
    plt.text(-0.01, -0.02,'Samples : %d' % smax,
        horizontalalignment='left',
        verticalalignment='top',
        transform = ax.transAxes, size=12)
    
    #plt.ylim(-2,2)
    plot_out_filename = "bitseeker_34401a_fx.png"
    fig.savefig(plot_out_filename, facecolor=fig.get_facecolor(), transparent=False)
    plt.show()